using System.Security.Cryptography.X509Certificates;

namespace FitConnect;

public interface IEncryption {
    /// <summary>
    ///     Just for Proof of Concept
    /// </summary>
    /// <returns></returns>
    string GetTestToken();

    void ImportCertificate(X509Certificate2 cert);

    /// <summary>
    ///     Import a public key from a PEM file
    /// </summary>
    /// <param name="certificatePath"></param>
    /// <param name="password">Password for the certificate</param>
    /// <exception cref="ArgumentException"></exception>
    /// <exception cref="Exception"></exception>
    void ImportCertificate(string certificatePath, string password);

    byte[] DecryptDataAsync(byte[] data);
    byte[] ExportPublicKey();
    byte[] ExportPrivateKey();
    byte[] EncryptData(byte[] data);
    byte[] EncryptData(byte[] data, byte[] publicKey);
}
